Package: org.gradle.api.tasks.scala

## [Java] Class ScalaCompileOptions

- org.gradle.api.tasks.scala.ScalaCompileOptions

- Options for Scala compilation.

- - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `protected boolean` | `excludeFromAntProperties(String fieldName)`
    `List<String>` | `getAdditionalParameters()` Additional parameters passed to the compiler.
    `protected String` | `getAntPropertyName(String fieldName)`
    `protected Object` | `getAntPropertyValue(String fieldName, Object value)`
    `String` | `getDaemonServer()` Server (host:port) on which the compile daemon is running.
    `String` | `getDebugLevel()` Generate debugging information.
    `String` | `getEncoding()` Encoding of source files.
    `String` | `getForce()` Whether to force the compilation of all files.
    `ScalaForkOptions` | `getForkOptions()` Options for running the Scala compiler in a separate process.
    `IncrementalCompileOptions` | `getIncrementalOptions()`
    `String` | `getLoggingLevel()` Specifies the amount of logging.
    `List<String>` | `getLoggingPhases()` Phases of the compiler to log.
    `boolean` | `isDeprecation()` Generate deprecation information.
    `boolean` | `isFailOnError()` Fail the build on compilation errors.
    `boolean` | `isFork()` Whether to run the Scala compiler in a separate process.
    `boolean` | `isListFiles()` List files to be compiled.
    `boolean` | `isOptimize()` Run optimizations.
    `boolean` | `isUnchecked()` Generate unchecked information.
    `boolean` | `isUseAnt()` Tells whether to use Ant for compilation.
    `boolean` | `isUseCompileDaemon()` Whether to use the fsc compile daemon.
    `void` | `setAdditionalParameters(List<String> additionalParameters)`
    `void` | `setDaemonServer(String daemonServer)`
    `void` | `setDebugLevel(String debugLevel)`
    `void` | `setDeprecation(boolean deprecation)`
    `void` | `setEncoding(String encoding)`
    `void` | `setFailOnError(boolean failOnError)`
    `void` | `setForce(String force)`
    `void` | `setFork(boolean fork)`
    `void` | `setForkOptions(ScalaForkOptions forkOptions)`
    `void` | `setIncrementalOptions(IncrementalCompileOptions incrementalOptions)`
    `void` | `setListFiles(boolean listFiles)`
    `void` | `setLoggingLevel(String loggingLevel)`
    `void` | `setLoggingPhases(List<String> loggingPhases)`
    `void` | `setOptimize(boolean optimize)`
    `void` | `setUnchecked(boolean unchecked)`
    `void` | `setUseAnt(boolean useAnt)`
    `void` | `setUseCompileDaemon(boolean useCompileDaemon)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class AbstractOptions` | `define, excludeFromAntProperties, getAntPropertyName, getAntPropertyValue, optionMap`
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Method Detail

    - #### protected boolean excludeFromAntProperties(String fieldName)

    - #### public List<String> getAdditionalParameters()

      Additional parameters passed to the compiler. Each parameter must start with '-'.

    - #### protected String getAntPropertyName(String fieldName)

    - #### protected Object getAntPropertyValue(String fieldName, Object value)

    - #### public String getDaemonServer()

      Server (host:port) on which the compile daemon is running. The host must share disk access with the client process. If not specified, launches the daemon on the localhost. This parameter can only be specified if useCompileDaemon is true.

    - #### @Input @Optional public String getDebugLevel()

      Generate debugging information. Legal values: none, source, line, vars, notailcalls

    - #### @Input @Optional public String getEncoding()

      Encoding of source files.

    - #### public String getForce()

      Whether to force the compilation of all files. Legal values: - never (only compile modified files) - changed (compile all files when at least one file is modified) - always (always recompile all files)

    - #### public ScalaForkOptions getForkOptions()

      Options for running the Scala compiler in a separate process. These options only take effect if `fork` is set to `true`.

    - #### @Nested public IncrementalCompileOptions getIncrementalOptions()

    - #### public String getLoggingLevel()

      Specifies the amount of logging. Legal values: none, verbose, debug

    - #### public List<String> getLoggingPhases()

      Phases of the compiler to log. Legal values: namer, typer, pickler, uncurry, tailcalls, transmatch, explicitouter, erasure, lambdalift, flatten, constructors, mixin, icode, jvm, terminal.

    - #### public boolean isDeprecation()

      Generate deprecation information.

    - #### public boolean isFailOnError()

      Fail the build on compilation errors.

    - #### public boolean isFork()

      Whether to run the Scala compiler in a separate process. Defaults to `false` for the Ant based compiler (`useAnt = true`), and to `true` for the Zinc based compiler (`useAnt = false`).

    - #### public boolean isListFiles()

      List files to be compiled.

    - #### @Input public boolean isOptimize()

      Run optimizations.

    - #### public boolean isUnchecked()

      Generate unchecked information.

    - #### public boolean isUseAnt()

      Tells whether to use Ant for compilation. If `true`, the standard Ant scalac (or fsc) task will be used for Scala and Java joint compilation. If `false`, the Zinc incremental compiler will be used instead. The latter can be significantly faster, especially if there are few source code changes between compiler runs. Defaults to `true`.

    - #### public boolean isUseCompileDaemon()

      Whether to use the fsc compile daemon.

    - #### public void setAdditionalParameters(List<String> additionalParameters)

    - #### public void setDaemonServer(String daemonServer)

    - #### public void setDebugLevel(String debugLevel)

    - #### public void setDeprecation(boolean deprecation)

    - #### public void setEncoding(String encoding)

    - #### public void setFailOnError(boolean failOnError)

    - #### public void setForce(String force)

    - #### public void setFork(boolean fork)

    - #### public void setForkOptions(ScalaForkOptions forkOptions)

    - #### public void setIncrementalOptions(IncrementalCompileOptions incrementalOptions)

    - #### public void setListFiles(boolean listFiles)

    - #### public void setLoggingLevel(String loggingLevel)

    - #### public void setLoggingPhases(List<String> loggingPhases)

    - #### public void setOptimize(boolean optimize)

    - #### public void setUnchecked(boolean unchecked)

    - #### public void setUseAnt(boolean useAnt)

    - #### public void setUseCompileDaemon(boolean useCompileDaemon)